/*                                                    */
/* Temple of Apshite by HugoFurst 06_12_2004          */
/* just an assload of bad code lashed onto            */
/* Rico's GP32 Programming Tutorial, part 2 + 3       */

/* my humble thanks and apologies to Rico, Mr. Spiv & Gruntfuggly    */

/*   Example source */

#include <stdlib.h>
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmain.h"
#include "gpstdio.h"
#include "gpfont.h"
#include "artworkA.h"
#include "artworkB.h"
#include "testmap.h"
#include "splash.h"



#define TILESIZE 32
#define MAPH 100
#define MAPW 100

int py, px, ex, ey, exmax, eymax, facing, walk;
int strength, dexterity, wisdom, intel, constit, charis, experience, silver, weight, health, fatigue, rest, roll;

unsigned char map[MAPW][MAPH];
char tmp_string[256], player[32];



void GpMain(void *arg)
{
  Init();
  RollPlayer();
  DoSplash();
  GameEngine();
  GpAppExit();
}

void Init()
{
  int i, j;
  GpClockSpeedChange(132000000, 0x24001, 2); /* speed = 133 Mhz */

  /* Page-flipper - we need to keep track of which video page we're on. We'll start with page 1. */
  nflip = 1;

  /* Enable and clear LCD screen:
     go through each page (this loop is a little pointless) and register it as a 'page' with the GP32. */ 
  for(i = 0; i < 2 ; i++)
  {
    GpLcdSurfaceGet(&gpDraw[i], i); 
  } 
  /* Here we wipe the first screen clear white - it starts off with random garbage. We don't need to clear screen 0, since it
     is a direct copy of screen 1. */ 
  GpRectFill(NULL, &gpDraw[nflip], 0, 0, gpDraw[nflip].buf_w, gpDraw[nflip].buf_h, 0x00);

  /* The GP32 needs to know to show screen 0 on the LCD, while we show screen 1 */
  GpSurfaceSet(&gpDraw[0]);

  /* The random values all come from one number, this case 36547. The random numbers will be
     the same every time this way, but we'll improve that later */
  /* srand(36547);   */

  facing = 1;
  walk = 1;
  rest = 1;
  py = px = 1600;
  exmax = MAPW * TILESIZE - 360;
  eymax = MAPH * TILESIZE - 240;
  
  for(i = 0; i < MAPW; i++)
  {
    for(j = 0; j < MAPH; j++)
    {
      map[i][j] = (unsigned char)(testmap[i][j] ) ;
    }
  }
}

void GameEngine()
{
  while ((GpKeyGet() & (GPC_VK_FL | GPC_VK_FR | GPC_VK_START)) != (GPC_VK_FL | GPC_VK_FR | GPC_VK_START))
  {
  HandleInput();
  
  rest++;
  if (rest > 100) 
	{ rest = 1;
	  fatigue++;
	}


  
	if (px < 52) px = 52; 
	if (px > 3110) px = 3110;
	if (py < 67) py = 67;
	if (py > 3112) py = 3112; 

  ex = px - 160;
  ey = py - 120;

  if (ex < 0) ex = 0;
  if (ey < 0) ey = 0;
  if (ex > exmax) ex = exmax;
  if (ey > eymax) ey = eymax; 
  DrawTiles(ex, ey);
    /* Now we tell the LCD to swtich to the next page, and tell our program to draw on the next page
       e.g. at the start of the code, LCD is set to 0, drawing (nflip) is set to 1
       Now LCD is set to 1, nflip is set to 0 ... clever eh? */


	if ( walk < 40 ) 
		{
		GpTransBlt(NULL, &gpDraw[nflip], px - ex - 5, py - ey - 5, TILESIZE, TILESIZE, (unsigned char*) sprite_artworkA, (6 + facing) * TILESIZE,  0, sprite_artworkA_width, sprite_artworkA_height, 0x00);
                }
	if ( walk >=  40 )
		{
		GpTransBlt(NULL, &gpDraw[nflip], px - ex - 5, py - ey - 5, TILESIZE, TILESIZE, (unsigned char*) sprite_artworkB, (6 + facing) * TILESIZE,  0, sprite_artworkB_width, sprite_artworkB_height, 0x00);
		}
	if (walk > 80)
		{ walk = 0;
		  fatigue--;
		  fatigue--;
		}


    GpSurfaceFlip(&gpDraw[nflip++]);
    nflip &= 0x01;
  
   }
}




void DrawTiles (int x, int y)
{
  int xtile, ytile, xpos, ypos, i, j, tile;
  /* Getting starting tile to draw at */
  xtile = x / TILESIZE;
  ytile = y / TILESIZE;
  /* Get the pixel offset to draw at
     By the way, 'xpos = x & 31' is the same as 'xpos = x % 32' but faster */
  xpos = x & (TILESIZE - 1);
  ypos = y & (TILESIZE - 1);
 
  /* Now draw the tiles */
  for(i = 0; i < (320/TILESIZE + 1); i++)
  {
    for(j = 0; j < (240/TILESIZE + 2); j++)
    {
      /* Get tile number to draw, draw it */
     	tile = map[ytile + j][xtile + i];
        GpBitBlt(NULL, &gpDraw[nflip], i * TILESIZE - xpos, j * TILESIZE - ypos, TILESIZE, TILESIZE, (unsigned char*) sprite_artworkA, tile * TILESIZE ,  0, sprite_artworkA_width, sprite_artworkA_height);

    }
  }
}


char pixel_col(int x, int y) 
	{ return map[x / 32][y / 32]; }


void HandleInput()
{
 int goodtile, xtile, ytile;
 ExKey = GpKeyGet();

 xtile = px / TILESIZE ;
 ytile = py / TILESIZE ;
 

 if (ExKey & GPC_VK_LEFT) 
	{	
		goodtile = map[xtile][ytile];
		if (goodtile <= 0)
		{
		px--;
		facing = 1;
		walk++;
		}
	}
 if (ExKey & GPC_VK_RIGHT)
	{
		goodtile = map[xtile + 1][ytile];
		if (goodtile <= 0)
		{
		px++;
		facing = 3;
		walk++;
		}
	}
 if (ExKey & GPC_VK_UP) 
	{	
		goodtile = map[xtile][ytile - 1];
		if (goodtile <= 0)
		{
		py--;
		facing = 2;
		walk++;
		}
	}
 if (ExKey & GPC_VK_DOWN) 
	{	
		goodtile = map[xtile][ytile + 1];
		if (goodtile <= 0)
		{
		py++;
		facing = 4;
		walk++;
		}
	}
 if (ExKey & GPC_VK_SELECT)
	{
		
		 GpRectFill(NULL, &gpDraw[nflip], 0, 0, gpDraw[nflip].buf_w, gpDraw[nflip].buf_h, 0xff);


		sprintf(tmp_string, "player : %s", player); 
		GpTextOut(NULL, &gpDraw[nflip], 20, 20, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "strength     : %d", strength); 
		GpTextOut(NULL, &gpDraw[nflip], 20, 40, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "intelligence : %d", intel); 
		GpTextOut(NULL, &gpDraw[nflip], 170, 40, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "dexterity    : %d", dexterity); 
		GpTextOut(NULL, &gpDraw[nflip], 20, 60, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "wisdom       : %d", wisdom); 
		GpTextOut(NULL, &gpDraw[nflip], 170, 60, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "constitution : %d", constit); 
		GpTextOut(NULL, &gpDraw[nflip], 20, 80, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "charisma     : %d", charis); 
		GpTextOut(NULL, &gpDraw[nflip], 170, 80, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "experience : %d", experience); 
		GpTextOut(NULL, &gpDraw[nflip], 20, 120, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "health  : %d", health); 
		GpTextOut(NULL, &gpDraw[nflip], 170, 120, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "silver     : %d", silver); 
		GpTextOut(NULL, &gpDraw[nflip], 20, 140, (char *)tmp_string, 0x00);
		sprintf(tmp_string, "fatigue : %d", (fatigue/10)); 
		GpTextOut(NULL, &gpDraw[nflip], 170, 140, (char *)tmp_string, 0x00);



sprintf(tmp_string, "px= %d,py= %d,roll= %d", px, py, roll); 
GpTextOut(NULL, &gpDraw[nflip], 10, 200, (char *)tmp_string, 0x00);

		GpTextOut(NULL, &gpDraw[nflip], 60, 220, "Press Any Key to Continue", 0x00);

    		GpSurfaceFlip(&gpDraw[nflip++]);
    		nflip &= 0x01;

		while (!GpKeyGetEx(&ExKey));
		while (GpKeyGetEx(&ExKey));
		while (!GpKeyGetEx(&ExKey));

	}
}

void DoSplash()
{
		GpBitBlt(NULL, &gpDraw[nflip], 0, 0, 320, 240, (unsigned char *)splash, 0, 0, 320, 240);
    		GpSurfaceFlip(&gpDraw[nflip++]);
    		nflip &= 0x01;
		roll = 1;

		while (!GpKeyGetEx(&ExKey))
				{ roll ++;
			 	 if (roll > 65534) roll = 1;
				}

		while (GpKeyGetEx(&ExKey));
		while (!GpKeyGetEx(&ExKey));
		srand(roll);

}

void RollPlayer()
{


		strength = (unsigned char) (rand() %  13) + 5 ;
		dexterity = (unsigned char) (rand() %  13) + 5 ;
		wisdom = (unsigned char) (rand() %  10) + 8 ;
		intel = (unsigned char) (rand() %  10) + 8 ;
		constit = (unsigned char) (rand() %  13) + 5 ;
		charis = (unsigned char) (rand() %  10) + 8 ;
		experience = 10;
		silver = (unsigned char) (rand() %  30 ) + 60 ;
		weight = 0;
		health = 100 ;
		fatigue = 1000 ;
		roll = (unsigned char) (rand() % 3) + 1;

		sprintf(player, "bashalot"); 
		if ( roll = 1) sprintf(player, "ballnob");
		if ( roll = 2) sprintf(player, "assjack");
		if ( roll = 3) sprintf(player, "jerkass");
}




